#include <stdio.h>
#include <string.h>
#include <utmp.h>
#include <sys/types.h>
#include <sys/file.h>

#include <config.h>

int
SysWtmp(char *line, char *user, char *host)
{
    struct utmp utmp;
    int fd;

    memset((char *)&utmp, 0, sizeof(utmp));

    strncpy(utmp.ut_line, line, sizeof(utmp.ut_line));
    strncpy(utmp.ut_id, line + 3, sizeof(utmp.ut_id));
    time(&(utmp.ut_time));
    if (user) {
	/* start */
	utmp.ut_type = USER_PROCESS;
	utmp.ut_pid = getpid();
	strncpy(utmp.ut_user, user, sizeof(utmp.ut_user));
	if (host) strncpy(utmp.ut_host, host, sizeof(utmp.ut_host));
    } else {
	/* stop */
	utmp.ut_type = DEAD_PROCESS;
    }
    fd = open(_PATH_WTMP, O_APPEND|O_WRONLY|O_CREAT, 0644);
    if (fd < 0) {
	LogError(_PATH_WTMP);
	return(-1);
    }
    write(fd, (char *)&utmp, sizeof(utmp));
    close(fd);
    return(0);
}
